/*******************************************************************************
* Copyright (c) 2007 IONA Technologies PLC
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
* 
* Contributors:
*     IONA Technologies PLC - initial API and implementation
*******************************************************************************/
package org.eclipse.stp.soas.internal.deploy.core.cp;

import java.util.List;

import org.eclipse.datatools.connectivity.ICategory;

public class StpCategoryProvider implements ICategory {

	  ICategory dtpCategory = null;
	
	  public StpCategoryProvider(ICategory cat) {
		  dtpCategory = cat;
	  }

	  public String getId() {
		  return dtpCategory.getId();
	  }
	  
	  public String getName() {
		  return dtpCategory.getName();
	  }
	  
	  public ICategory getParent() {
		  return dtpCategory.getParent();
	  }
	  
	  @SuppressWarnings("unchecked")
	  public List getChildCategories() {
		  return dtpCategory.getChildCategories();
	  }
	  
	  @SuppressWarnings("unchecked")
	  public List getAssociatedProfiles() {
		  //need to change here to get from wtp too
		  return dtpCategory.getAssociatedProfiles();
	  }

}
